//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  AssignPrn gpeLXg̈ 
//  ̗]ݒ肷
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0420 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//  BDE 5.2 + Paradox 7.0
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  plSetPrinter;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    plSetPrinter1: TplSetPrinter;
    PrinterSetupDialog1: TPrinterSetupDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    procedure SetViewPortOffset(ASetPrt: TplSetPrinter; ALeft, ATop,
      ARight, ABottom: Integer);
    function mmToPixelsX(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
    function mmToPixelsY(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
  end;

  var
  Form1: TForm1;

implementation

uses
  Printers;

{$R *.dfm}

//=============================================================================
//  tH[̏
//  eLXgt@Cǂݍ                                          //
//=============================================================================                                           //
procedure TForm1.FormCreate(Sender: TObject);
var
  LFilePath : string;
begin
  Memo1.WordWrap   := True;
  Memo1.ScrollBars := ssVertical;

  LFilePath := ExpandFileName('..\Test.txt');
  Memo1.Lines.LoadFromFile(LFilePath);
end;

//=============================================================================
//  TMemo ̃eLXg]ݒ肵Ĉ
//  AssignPrn gp@́Cłɂ܂镶̈\
//
//  uses  Printers Kv
//  ٍ TplSetPritner R|[lgKv
//=============================================================================                                           //

procedure TForm1.Button1Click(Sender: TObject);
var
  LFontSize  : Integer;
  LStrList   : TStringList;
  LPrnFile   : TextFile;
  LLeftOff   : Integer;
  LTopOff    : Integer;
  LRightOff  : Integer;
  LBottomOff : Integer;
  LIndex     : Integer;
begin
  if not PrinterSetupDialog1.Execute then Exit;

  Printer.Title := 'eXg';
  LFontSize := 16;
  Printer.Canvas.Font.Size := LFontSize;

  AssignPrn(LPrnFile);
  try
    LStrList := TStringList.Create;
    Rewrite(LPrnFile);
    try
      // ]̒l
      LLeftOff   := mmToPixelsX(plSetPrinter1, 20);
      LTopOff    := mmToPixelsY(plSetPrinter1, 30);
      LRightOff  := mmToPixelsX(plSetPrinter1, 20);
      LBottomOff := mmToPixelsY(plSetPrinter1, 25);

      // ]̐ݒ
      SetViewPortOffset(plSetPrinter1, LLeftOff, LTopOff, LRightOff, LBottomOff);

      LStrList.Text := Memo1.Lines.Text;

      // sPʂň
      for LIndex := 0 to LStrList.Count - 1 do begin
        Writeln(LPrnFile, LStrList[LIndex]);
        Application.ProcessMessages;
      end;

      // r[|[g (]) ̐ݒƃtHg̃TCYɖ߂
      SetViewPortOffset(plSetPrinter1, 0, 0, 0, 0);
      Printer.Canvas.Font.Size := LFontSize;
    finally
      CloseFile(LPrnFile);
      FreeAndNil(LStrList);
    end;
  except
    on EInOutError do
      MessageBox(Handle, 'G[', '', MB_ICONWARNING);
  end;
end;

//-----------------------------------------------------------------------------
//  ̗]̐ݒ
//   1  TplSetPrinter R|[lg
//  ͍̈[C[CE[C[̃ItZbgŃsNZP
//
//  ۂɂ͗pTCỸr[|[gݒ肵Ăɕ`悷
//  ܂Ck`悷
//  ̕@́Cݒ肵]̊Oɂ͕`łȂ (pŜ̏kȂ̂)
//
//  uses  Printers Kv
//  ٍ TplSetPritner R|[lgKv
//-----------------------------------------------------------------------------
procedure TForm1.SetViewPortOffset(ASetPrt: TplSetPrinter; ALeft, ATop,
  ARight, ABottom: Integer);
var
  LPaperW : Integer;
  LPaperH : Integer;
begin
  LPaperW := ASetPrt.PaperWidth;
  LPaperH := ASetPrt.PaperHeight;

  SetMapMode       (Printer.Canvas.Handle, MM_ANISOTROPIC);
  SetWindowExtEx   (Printer.Canvas.Handle, LPaperW, LPaperH, nil);
  SetViewPortExtEx (Printer.Canvas.Handle,
                    LPaperW - (ALeft + ARight),
                    LPaperH - (ATop + ABottom),
                    nil);
  // `挴_ړ
  SetViewPortOrgEx(Printer.Canvas.Handle, ALeft, ATop, nil);

  // r[|[g̋@\ŕ`k̂ł̕tHg̃TCY傫
  Printer.Canvas.Font.Height := Trunc(Printer.Canvas.Font.Height
               *  LPaperH / (LPaperH - (ATop + ABottom)));
end;
//
//-----------------------------------------------------------------------------
//  mm Pʂ TPrinter.Canvas ̃sNZɕϊ
//  p
//-----------------------------------------------------------------------------
function TForm1.mmToPixelsX(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
begin
  Result := Trunc(AValue * ASetPrt.XResolution / 25.4);
end;

//-----------------------------------------------------------------------------
//  mm Pʂ TPrinter.Canvas ̃sNZɕϊ
//  cp
//-----------------------------------------------------------------------------
function TForm1.mmToPixelsY(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
begin
  Result := Trunc(AValue * ASetPrt.YResolution / 25.4);
end;

end.
