//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  AssignPrn gpeLXg̈ 
//  Canvas.TextRect gp (ŏ 1 y[W\)
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2020N0420 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE5(UP2) Pro VCL-32
//  BDE 5.2 + Paradox 7.0
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  plSetPrinter;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    plSetPrinter1: TplSetPrinter;
    PrinterSetupDialog1: TPrinterSetupDialog;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
    function mmToPixelsX(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
    function mmToPixelsY(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
  end;

  var
  Form1: TForm1;

implementation

uses
  Printers;

{$R *.dfm}

//=============================================================================
//  tH[̏
//  eLXgt@Cǂݍ                                          //
//=============================================================================                                           //
procedure TForm1.FormCreate(Sender: TObject);
var
  LFilePath : string;
begin
  Memo1.WordWrap   := True;
  Memo1.ScrollBars := ssVertical;

  LFilePath := ExpandFileName('..\Test.txt');
  Memo1.Lines.LoadFromFile(LFilePath);
end;

//=============================================================================
//  TMemo ̃eLXg]ݒ肵Ĉ
//  Canvas.TextRect gp (ŏ 1 y[W\)
//
//  uses  Printers Kv
//  ٍ TplSetPritner R|[lgKv
//=============================================================================                                           //

procedure TForm1.Button1Click(Sender: TObject);
var
  LFormat  : TTextFormat;
  LRect    : TRect;
  LPrnText : string;
begin
  if not PrinterSetupDialog1.Execute then Exit;

  Printer.Title := 'eXg';
  Printer.Canvas.Font.Size := 15;

  Printer.BeginDoc;
  try
    // ̈̐ݒ
    LRect := Printer.Canvas.ClipRect;
    LRect.Left  := mmToPixelsX(plSetPrinter1, 20);
    LRect.Top    := mmToPixelsY(plSetPrinter1, 30);
    LRect.Right  := plSetPrinter1.PaperWidth - mmToPixelsX(plSetPrinter1, 20);
    LRect.Bottom := plSetPrinter1.PaperHeight - mmToPixelsY(plSetPrinter1, 25);

    // 
    LFormat  := [tfLeft, tfWordBreak];
    LPrnText := Memo1.Lines.Text;
    Printer.Canvas.TextRect(LRect, LPrnText, LFormat);
  finally
    Printer.EndDoc;
  end;
end;

//-----------------------------------------------------------------------------
//  mm Pʂ TPrinter.Canvas ̃sNZɕϊ
//  p
//-----------------------------------------------------------------------------
function TForm1.mmToPixelsX(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
begin
  Result := Trunc(AValue * ASetPrt.XResolution / 25.4);
end;

//-----------------------------------------------------------------------------
//  mm Pʂ TPrinter.Canvas ̃sNZɕϊ
//  cp
//-----------------------------------------------------------------------------
function TForm1.mmToPixelsY(ASetPrt: TplSetPrinter; AValue: Integer): Integer;
begin
  Result := Trunc(AValue * ASetPrt.YResolution / 25.4);
end;

end.
